/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: chip_sil.h 843 2011-07-15 03:17:19Z ertl-honda $
 */

/*
 *   sil.hΥåװ¸MPCOREѡ
 *
 *  Υ󥯥롼ɥեϡsil.hƬǥ󥯥롼ɤ롥¾Υե
 *  뤫ľܥ󥯥롼ɤ뤳ȤϤʤΥե򥤥󥯥롼
 *  ɤˡt_stddef.h󥯥롼ɤΤǡ˰¸Ƥ
 *  褤
 */

#ifndef TOPPERS_CHIP_SIL_H
#define TOPPERS_CHIP_SIL_H

/*
 *  ARMǶ̤
 */
#include "arm_armcc/common/core_sil.h"

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ץåIDμ
 */
Inline void
sil_get_pid(ID *p_prcid)
{
	register uint32_t cp15_cpuid __asm("cp15:0:c0:c0:5");

	*p_prcid = (cp15_cpuid & 0x0f) + 1;
}

/*
 *  ԥåѿchip_config.c
 */
extern uint32_t TOPPERS_spn_var;

/*
 *  ԥåμ
 */
Inline uint32_t
TOPPERS_sil_loc_spn(void)
{
	uint32_t irq_fiq_mask; 
	register uint32_t locked;
	uint32_t pre_cpsr_c;
	uint32_t dis_cpsr_c;
	ID       prcid;
	register uint32_t cpsr __asm("cpsr");

	sil_get_pid(&prcid);

	/* ƤӽФcpsrbit07ξ */
	pre_cpsr_c = cpsr;

	/* ߥå֤ */
	irq_fiq_mask = TOPPERS_disint();

	/* ߥåְܹԸcpsrbit07ξ */
	dis_cpsr_c = cpsr;

	while(true) {
		locked = __ldrex(&TOPPERS_spn_var);
		if (locked != 0) {
			cpsr = pre_cpsr_c;  /* ƤӽФξ֤ءʳߵġ */
			__wfe();
			cpsr = dis_cpsr_c;  /* ߥå֤ */
		} else {
			locked = __strex(prcid, &TOPPERS_spn_var);
		}

		if (locked == 0) {
			/* ԥå */
			/* Data meory barrier */
#if __TARGET_ARCH_ARM == 6
			{
				register uint32_t cp15_dmb __asm("cp15:0:c7:c10:5");
				cp15_dmb = 0;
			}
#elif __TARGET_ARCH_ARM == 7
			__dmb(0xf)
#endif /* __TARGET_ARCH_ARM == 7 */
			__memory_changed();
			return irq_fiq_mask;
		}
	}
}

/*
 *  ԥåֵ
 */
Inline void
TOPPERS_sil_unl_spn(uint32_t irq_fiq_mask)
{
	/* Ƥ񤭴ǽ */
	__memory_changed();
	/* Data meory barrier */
#if __TARGET_ARCH_ARM == 6
	{
		register uint32_t cp15_dmb __asm("cp15:0:c7:c10:5");
		cp15_dmb = 0;
	}
#elif __TARGET_ARCH_ARM == 7
	__dmb(0xf)
#endif /* __TARGET_ARCH_ARM == 7 */
	TOPPERS_spn_var = 0U;
	/* Data Sync Barrier */
#if __TARGET_ARCH_ARM == 6
	{
		register uint32_t cp15_dsb __asm("cp15:0:c7:c10:5");
		cp15_dsb = 0;
	}
#elif __TARGET_ARCH_ARM == 7
	__dsb(0xf)
#endif /* __TARGET_ARCH_ARM == 7 */
	/* ԥåԤΥإ٥Ȥ */
	__sev();

	/* ԥåμξ֤ */
	TOPPERS_set_fiq_irq(irq_fiq_mask);
}

/*
 *  ԥåζ
 *  ץåԥåƤ˲롥 
 */
Inline void
TOPPERS_sil_force_unl_spn(void)
{
	ID prcid;

	sil_get_pid(&prcid);

	if (TOPPERS_spn_var == prcid) {
		TOPPERS_spn_var = 0U;
		/* ԥåԤΥإ٥Ȥ */
		__sev();
	}
}

/*
 *  ԥå
 */
#define SIL_LOC_SPN() ((void)(TOPPERS_irq_fiq_mask = TOPPERS_sil_loc_spn()))
#define SIL_UNL_SPN() (TOPPERS_sil_unl_spn(TOPPERS_irq_fiq_mask))

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_CHIP_SIL_H */
