/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel  
 * 
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: naviengine.h 787 2011-03-03 02:58:54Z ertl-honda $
 */

/*
 *  NaviEngineѥɥ饤
 */

#ifndef TOPPERS_NAVIENGINE_H
#define TOPPERS_NAVIENGINE_H

#include <sil.h>

/*
 * å400MHz
 */
#define NAVIENGINE_CORE_CLK  400

/*
 *  MPCore Private Memory Regin Base Address
 */
#define MPCORE_PMR_BASE  0xc0000000

/*
 *  MPCore Status
 */
#define NAVIENGINE_MPCORE_STATUS  0x18037D08

/*
 *  MPCore¢Υޤ1MHzư뤿Υץꥹ顼
 */
#define MPCORE_TM_PS_1MHZ    199   /* å399Mhz */

/*
 *  UARTΥ쥸
 */
#define UART0_BASE		0x18034000
#define UART1_BASE		0x18034400
#define UART2_BASE		0x18034800
#define UART3_BASE		0x18034C80
#define UART4_BASE		0x180350c0

#define	UART_RBR_REG		(0x0 )
#define	UART_THR_REG		(0x0 )
#define	UART_DLL_REG		(0x00)
#define	UART_IER_REG		(0x04)
#define	UART_DLM_REG		(0x04)
#define	UART_IIR_REG		(0x08)
#define	UART_LCR_REG		(0x0c)
#define	UART_MCR_REG		(0x10)
#define	UART_LSR_REG		(0x14)
#define	UART_MSR_REG		(0x18)
#define	UART_SCR_REG		(0x1c)
#define	UART_FCR_REG		(0x20)

/*
 * ֹ
 */
#define DIC_IRQNO_UART0   86
#define DIC_IRQNO_UART1   87
#define DIC_IRQNO_UART2   88
#define DIC_IRQNO_UART3   89

/*
 *  
 */
#define UART0_LCR_VAL 0x03
#define UART0_DLM_VAL 0x00
#define UART0_DLL_VAL 0xd8

#define UART1_LCR_VAL 0x03
#define UART1_DLM_VAL 0x00
#define UART1_DLL_VAL 0xd8

#define UART2_LCR_VAL 0x03
#define UART2_DLM_VAL 0x00
#define UART2_DLL_VAL 0xd8

#define UART3_LCR_VAL 0x03
#define UART3_DLM_VAL 0x00
#define UART3_DLL_VAL 0xd8

#ifndef TOPPERS_MACRO_ONLY
/*
 *  UARTΥݡ󥰽
 */
extern void naviengine_uart_putc(char_t c);

/*
 * ݡ󥰽ϤΤν
 */
extern void naviengine_uart_init(void);
#endif /* TOPPERS_MACRO_ONLY */

#define DIC_TMIN_INTNO    0U
#define DIC_TMAX_INTNO  127U
#define DIC_TNUM_INT    128U

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ȯĶ¸ν(T.B.D)
 */
Inline void
naviengine_exit(void)
{
	while(1);
}

/*
 *  ȥ졼˴ؤ
 *  SCUѤ롥 
 */
#define TRACE_HW_INIT()   scu_counter_init()
#define TRACE_GET_TIM()   ((scu_counter_get_current() * 1000) / NAVIENGINE_CORE_CLK)

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_NAVIENGINE_H */
